function A = householder(A)
% 
% function A = householder(A)
%
n = length(A);
I = eye(n);
for i = 1:n-2
  x = A(:,i);
  w = zeros(size(x));
  w(i+1) = x(i+1)+(2*(x(i+1)>=0)-1)*norm(x(i+1:n));
  w(i+2:n) = x(i+2:n);
  Q = I-2*w*w'/norm(w)^2;
  B = A*Q;
  A(1:n,i) = x-w;
  A(1:n,i+1:n) = Q*B(1:n,i+1:n);
end
