function [d,iter,stimaerr] = jacobi(A,tol,maxit)
%
% function d = jacobi(A,tol,maxit)
%
n = length(A);
D = A;
stimaerr = tol+1;
iter = 0;
while ((stimaerr > tol) & (iter < maxit))
  m = max(max(abs(D)));
  [mc,p] = max(tril(-2*m*ones(n))+abs(D));
  [mr,q] = max(mc);
  p = p(q);
%  oppure
%  m = 0;  
%  for i = 1:n
%     for j = i+1:n
%       if (abs(D(i,j)) >= m)
%         p = i;
%         q = j;
%         m = abs(D(i,j));
%       end
%     end
%  end
  if (D(p,q) ~= 0)
    eta = (D(q,q)-D(p,p))/(2*D(p,q));
    t = (2*(eta >= 0)-1)/((2*(eta >= 0)-1)*eta+sqrt(1+eta^2));
  else
    t = 0;
  end    
  c = 1/sqrt(1+t^2);
  s = c*t;
  G = eye(n);
  G(p,p) = c;
  G(p,q) = s;
  G(q,p) = -s;
  G(q,q) = c;
  D = G'*D*G;
  stimaerr = sqrt(sum(sum((D-spdiags(diag(D),0,n,n)).^2)));
  iter = iter+1;
end
if (stimaerr > tol)
  warning('Impossibile raggiungere la tolleranza richiesta')
  warning('entro il numero massimo di iterazioni consentito.')
end
d = diag(D);
