function [lambda,y,iter,stimaerrore] = potenzeinverse(A,x,tol,maxit,varargin)
%
%  [lambda,y,iter,stimaerrore] = potenzeinverse(A,x,tol,maxit,varargin)
%
if (nargin == 5)
  mu = varargin{1};
else
  mu = 0;
end
if (length(A) == 1)
  lambda = A;
  y = 1;
  iter = 0;
  stimaerrore = 0;
  return
end
y = x/norm(x);
[L,U,P] = lu(A-mu*eye(size(A)));
z = L\(P*y);
x = U\z;
iter = 1;
lambda0 = y'*x;
y = x/norm(x);
stimaerrore = tol+1;
while ((stimaerrore > tol) & (iter < maxit))
  z = L\(P*y);
  x = U\z;
  iter = iter+1;
  lambda = y'*x;
  stimaerrore = abs(lambda-lambda0);
  y = x/norm(x);
  lambda0 = lambda;
end
lambda = mu+1/lambda;
if (stimaerrore > tol)
  warning('Impossibile raggiungere la tolleranza richiesta')
  warning('entro il numero massimo di iterazioni consentito.')
end
